<script setup lang="ts">
import type { Customer } from '@/types/Customer'
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import { useCustomerStore } from '@/stores/customer'
import { useLoadingStore } from '@/stores/loading'

const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Tel',
    key: 'tel',
    value: 'tel'
  },
  {
    title: 'Point',
    key: 'point',
    value: 'point'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const customerStore = useCustomerStore()
const loadingStore = useLoadingStore()
const form = ref(false)
const loading = ref(false)
const dialog = ref(false)
const dialogDelete = ref(false)
const refForm = ref<VForm | null>(null)
let editedIndex = -1
let lastId = 1
let lastPoint = 1

function onSubmit() {}
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    customerStore.clearForm()
  })
}

async function deleteItemConfirm() {
  await customerStore.deleteCustomer()
  closeDelete()
}

async function editItem(item: Customer) {
  if (!item.id) return
  await customerStore.getCustomer(item.id)
  dialog.value = true
}

async function deleteItem(item: Customer) {
  if (!item.id) return
  await customerStore.getCustomer(item.id)
  dialogDelete.value = true
  editedIndex = -1
}

onMounted(() => {
  customerStore.getCustomers()
})
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    customerStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await customerStore.saveCustomer()
  closeDialog()
}
</script>
<template>
  <div>
    <v-data-table :headers="headers" :items="customerStore.customers" class="custom-datatable">
      <template v-slot:top>
        <v-toolbar flat style="background-color: rgb(247, 156, 82)">
          <v-toolbar-title style="color: white">Member Management</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn
                prepend-icon="mdi-plus"
                outlined
                v-bind="props"
                style="color: white; background-color: green"
                >New Member</v-btn
              >
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Customer Member</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="customerStore.editedCustomer.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="customerStore.editedCustomer.tel"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Tel"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="customerStore.editedCustomer.point"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Point"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>***indicates required field***</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()">Close</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()">Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- </v-row> -->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Delete?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">Yes</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" color="blue-accent-4" class="me-2" @click="editItem(item)"
          >mdi-pencil</v-icon
        >
        <v-icon size="small" color="red-accent-4" @click="deleteItem(item)">mdi-delete</v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="customerStore.getCustomers">Reset</v-btn>
      </template>
    </v-data-table>
  </div>
</template>
<style scoped>
.custom-datatable th {
  background-color: rgb(236, 235, 235);
  color: black;
  font-weight: bold !important; 
  font-size: 15px; /* Adjust the font size as needed */
}
</style>
